%.$(OBJEXT): $(SRCDIR)/%.c
	@echo "CC   $@"
	@$(CC) -c -o $@ $< $(CFLAGS)

%.$(OBJEXT): %.c
	@echo "CC   $@"
	@$(CC) -c -o $@ $< $(CFLAGS)

$(BLDDIR)/%.mo: $(SRCDIR)/%.po
	@echo "GEN  $@"
	@mkdir -p `dirname $@`
	@msgfmt -o $@ $<

%.mo: %.po
	@echo "GEN  $@"
	@msgfmt -o $@ $<

%.res: $(SRCDIR)/%.rc
	@echo "CONV `basename $<` -> $@"
	@i686-pc-mingw32-windres -O coff -o $@ $<

clean:
	rm -f $(OBJS) $(TARGETS) *.d depend.mk

$(LINKFILES):
	@for linkfile in $(LINKFILES) ; do \
	  (test ! -e $$linkfile && ln -s $(SRCDIR)/$$linkfile .) \
	done

recursive-all:
	@for subdir in $(SUBDIRS) ; do \
	  (mkdir -p $$subdir && cd $$subdir && make -f $(SRCDIR)/$$subdir/Makefile all) \
	done

recursive-clean:
	@for subdir in $(SUBDIRS) ; do \
	  (test -d $$subdir && cd $$subdir && make -f $(SRCDIR)/$$subdir/Makefile clean) \
	done

recursive-install:
	@for subdir in $(SUBDIRS) ; do \
	  (echo "---- $$subdir" && test -d $$subdir && cd $$subdir && make -s -f $(SRCDIR)/$$subdir/Makefile install) \
	done

depend depend.mk:
	@echo "depend"
	@touch $$dummy$$.d
	@cat *.d > depend.mk
	@rm -f $$dummy$$.d

-include depend.mk
