/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef allocation_h
#define allocation_h

#include <stddef.h>                     /* size_t */

typedef struct _Allocation Allocation;

struct _Allocation{
    size_t size;
    char* mem;
    unsigned int greedy:1;
};

Allocation* allocation_init(Allocation*,int greedy);
void allocation_done(Allocation*);

int allocation_try_ensure(Allocation*,size_t size);
char* allocation_ensure(Allocation*,size_t size,int preserve);
char* allocation_ensure_full(Allocation*,size_t size,const char* preserve_begin,size_t preserve_size);

#endif /* allocation_h */
