/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef dispatch_h
#define dispatch_h

typedef void(*DispatchFunc)(void*);

typedef struct _Dispatch Dispatch;

typedef struct{
    void(*done)(Dispatch*);
    void(*dispatch)(Dispatch*,DispatchFunc,void*);
    int(*try_dispatch)(Dispatch*,DispatchFunc,void*);
    void(*wait)(Dispatch*);
}DispatchInterface;

struct _Dispatch{
    const DispatchInterface* vt;
};

#define dispatch_done(a) (a)->vt->done(a)
void dispatch_free(Dispatch*);
#define dispatch_dispatch(a,b,c) (a)->vt->dispatch(a,b,c)
#define dispatch_try_dispatch(a,b,c) (a)->vt->try_dispatch(a,b,c)
#define dispatch_wait(a) (a)->vt->wait(a)

#endif /* dispatch_h */
