/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef genjs_h
#define genjs_h

#include "config.h"

#include "listmodel.h"
#include "rangemodel.h"
#include "session.h"

typedef void(*GenjsFunction)(Session*,const char*);
//typedef void(*GenjsCreateWidgetFunc)(UpWidget*,const char*);

#ifdef DEBUG
# define out(a,...) session_sendf(sess,a "\n",##__VA_ARGS__)
#else
# define out(a,...) session_sendf(sess,a,##__VA_ARGS__)
#endif

#define GEOMETRY_REQ "onr"
#define GEOMETRY_SET "ons"
#define EXPAND_WIDTH "ew"
#define EXPAND_HEIGHT "eh"
#define FILL_WIDTH "fw"
#define FILL_HEIGHT "fh"
#define SPACING "sp"
#define CHILD "c"
#define CHILDREN "c"

const char* genjs_get_function(Session*,GenjsFunction);
const char* genjs_get_element(UpWidget*);

/* --- list model --- */
const char* genjs_get_list_model(Session*,ListModel*);
/* --- range model --- */
void genjs_create_range_model_set(Session*,const char*);
#define genjs_get_range_model_set() genjs_get_function(sess,genjs_create_range_model_set)
void genjs_create_range_model_limits(Session*,const char*);
#define genjs_get_range_model_limits() genjs_get_function(sess,genjs_create_range_model_limits)
const char* genjs_get_range_model(Session*,RangeModel*);

void genjs_init(Session*);
void genjs_comet(Session*);
void genjs_resize(UpWidget*);

#endif /* genjs_h */
