/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef httpd_h
#define httpd_h

#include <stdarg.h>

typedef struct _Httpd Httpd;
typedef struct _HttpdConnection HttpdConnection;
typedef int(*HttpdRequestHandler)(void* userdata,HttpdConnection*,const char* url,const char* method,const char* version);

Httpd* httpd_new(int port,HttpdRequestHandler,void* userdata);
void httpd_free(Httpd*);

const char* httpd_get_args(HttpdConnection*);
char* httpd_get_cookie(HttpdConnection*,const char*);

void httpd_header_ok(HttpdConnection*);
void httpd_header_not_found(HttpdConnection*);
void httpd_header(HttpdConnection*,const char*,const char*);
void httpd_header_cookie(HttpdConnection*,const char*,const char*);
void httpd_header_end(HttpdConnection*);

//int httpd_steal_fd(HttpdRequest*);

void httpd_connection_close(HttpdConnection*);

int httpd_send(HttpdConnection*,const char* data,int len);
int httpd_sendf(HttpdConnection*,const char* format,...);
int httpd_sendvf(HttpdConnection*,const char* format,va_list);
int httpd_sendfile(HttpdConnection*,const char* filename,const char* mimetype);

#endif /* httpd_h */
