/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef mainloop_h
#define mainloop_h

#ifdef USE_GLIB
# define MAINLOOP_USE_GLIB
#endif

#include <signal.h>

#include "dispatch.h"
#include "eventloop.h"
#include "signals.h"

typedef int(*MainloopSignalFunc)(void*,int);

int mainloop_init(void);
void mainloop_done(void);

void mainloop_add_fd(int fd,EventloopFdFunc,void*);
void mainloop_add_timeout(int timeout,EventloopTimeoutFunc,void*);
SignalSubscription* mainloop_subscribe_signal(int signum,MainloopSignalFunc,void*);
void mainloop_unsubscribe_signal(int signum,SignalSubscription*);

int mainloop_run(void);
void mainloop_quit(void);

void mainloop_dispatch(DispatchFunc,void*);

#endif /* mainloop_h */
