/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef underpants_priv_h
#define underpants_priv_h

/* allocation.c */
#define allocation_done                 _UP_alloc_A
#define allocation_ensure               _UP_alloc_B
#define allocation_ensure_full          _UP_alloc_C
#define allocation_init                 _UP_alloc_D
#define allocation_try_ensure           _UP_alloc_E

/* array.c */
#define array_done                      _UP_array_A
#define array_foreach                   _UP_array_B
#define array_free                      _UP_array_C
#define array_free_full                 _UP_array_D
#define array_init                      _UP_array_E
#define array_insert                    _UP_array_F
#define array_new                       _UP_array_G
#define array_pop                       _UP_array_H
#define array_remove                    _UP_array_I
#define array_resize                    _UP_array_J
#define array_set                       _UP_array_K

/* asyncfifo.c */
#define async_fifo_fd                   _UP_afifo_A
#define async_fifo_free                 _UP_afifo_B
#define async_fifo_new                  _UP_afifo_C
#define async_fifo_pop                  _UP_afifo_D
#define async_fifo_push                 _UP_afifo_E
#define async_fifo_try_pop              _UP_afifo_F
#define async_fifo_wait                 _UP_afido_G

/* eventloop.c */
/*
#define eventloop_add_fd                _UP_eventloop_A
#define eventloop_add_timeout           _UP_eventloop_B
#define eventloop_dispatch              _UP_eventloop_C
#define eventloop_free                  _UP_eventloop_D
#define eventloop_new                   _UP_eventloop_E
#define eventloop_quit                  _UP_eventloop_F
#define eventloop_run                   _UP_eventloop_G
*/

/* hash.c */
#define direct_equal                    _UP_hash_A
#define direct_hash                     _UP_hash_B
#define hash_combine                    _UP_hash_C
#define hash_map_add                    _UP_hash_D
#define hash_map_foreach                _UP_hash_E
#define hash_map_free                   _UP_hash_F
#define hash_map_get                    _UP_hash_G
#define hash_map_new                    _UP_hash_H
#define hash_map_remove                 _UP_hash_I
#define hash_map_remove_all             _UP_hash_J
#define hash_map_size                   _UP_hash_K
#define int_equal                       _UP_hash_L
#define int_hash                        _UP_hash_M
#define pointer_hash                    _UP_hash_N
#define str_equal                       _UP_hash_O
#define str_hash                        _UP_hash_P
#define str_hash_update                 _UP_hash_Q

/* httpd.c */
//#define httpd_sendfile                  _UP_httpd_A

/* list.c */
#define list_find_custom                _UP_list_A
#define list_find_data                  _UP_list_B
#define list_foreach                    _UP_list_C
#define list_free                       _UP_list_D
#define list_free_full                  _UP_list_E
#define list_insert_after               _UP_list_F
#define list_insert_before              _UP_list_G
#define list_insert_sorted              _UP_list_H
#define list_remove                     _UP_list_I
#define list_remove_custom              _UP_list_J
#define list_remove_data                _UP_list_K

/* listmodel.c */
/*
list_model_done_func
list_model_init
list_model_row_data
list_model_row_done
list_model_row_first
list_model_row_free
list_model_row_init
list_model_row_iter
list_model_row_last
list_model_row_new
list_model_row_next
list_model_row_previous
list_model_row_set
list_model_store_append
list_model_store_get_iter
list_model_store_get_num
list_model_store_insert_after
list_model_store_insert_before
list_model_store_new
list_model_store_prepend
list_model_store_remove
list_model_store_remove_data
list_model_subscribe_add
list_model_subscribe_remove
*/

/* mainloop.c */

/* memchunk.c */
#define memchunk_done                   _UP_memchunk_A
#define memchunk_ensure_private         _UP_memchunk_B
#define memchunk_ensure_private_size_nopreserve _UP_memchunk_C
#define memchunk_ensure_size_full       _UP_memchunk_D
#define memchunk_ensure_writable        _UP_memchunk_E
#define memchunk_ensure_writable_size_nopreserve _UP_memchunk_F
#define memchunk_free                   _UP_memchunk_G
#define memchunk_init                   _UP_memchunk_H
#define memchunk_new                    _UP_memchunk_I
#define memchunk_set                    _UP_memchunk_J
#define memchunk_try_ensure_size        _UP_memchunk_K

/* queue.c */
#define queue_clear                     _UP_queue_A
#define queue_clear_full                _UP_queue_B
#define queue_find_custom               _UP_queue_C
#define queue_find_data                 _UP_queue_D
#define queue_free                      _UP_queue_E
#define queue_free_full                 _UP_queue_F
#define queue_insert_after              _UP_queue_G
#define queue_insert_before             _UP_queue_H
#define queue_pop_head                  _UP_queue_I
#define queue_pop_tail                  _UP_queue_J
#define queue_push_head                 _UP_queue_K
#define queue_push_tail                 _UP_queue_L
#define queue_remove                    _UP_queue_M

/* signals.c */

/* strn.c */
#define strn_append_char                _UP_strn_A
#define strn_appendf                    _UP_strn_B
#define strn_append_full                _UP_strn_C
#define strn_append_steal               _UP_strn_D
#define strn_appendvf                   _UP_strn_E
#define strn_copy_to                    _UP_strn_F
#define strn_done                       _UP_strn_G
#define strn_dup                        _UP_strn_H
#define strn_ensure_private             _UP_strn_I
#define strn_ensure_private_length      _UP_strn_J
#define strn_ensure_writable            _UP_strn_K
#define strn_ensure_writable_length     _UP_strn_L
#define strn_ensure_zero_terminated     _UP_strn_M
#define strn_equal                      _UP_strn_N
#define strn_free                       _UP_strn_O
#define strn_hash                       _UP_strn_P
#define strn_init                       _UP_strn_Q
#define strn_maybe_dup                  _UP_strn_R
#define strn_new                        _UP_strn_S
#define strn_setf                       _UP_strn_T
#define strn_set_full                   _UP_strn_U
#define strn_set_notify                 _UP_strn_V
#define strn_set_steal                  _UP_strn_W
#define strn_set_sub_strn               _UP_strn_X
#define strn_setvf                      _UP_strn_Y
#define strn_steal                      _UP_strn_Z
#define strn_trim                       _UP_strn_0

/* strutil.c */

/* uref.c */
#define u_ref_ref                       _UP_ref_A
#define u_ref_unref                     _UP_ref_B
#define u_strdupf                       _UP_ref_C
#define u_strdupvf                      _UP_ref_D
#define u_strset_steal                  _UP_ref_E

#endif /* underpants_priv_h */

/*
file_exists
get_imageinfo
httpd_connection_close
httpd_free
httpd_get_args
httpd_get_cookie
httpd_header
httpd_header_cookie
httpd_header_end
httpd_header_not_found
httpd_header_ok
httpd_new
httpd_send
httpd_sendf
httpd_sendfile
httpd_sendvf
mainloop_add_fd
mainloop_add_timeout
mainloop_dispatch
mainloop_done
mainloop_init
mainloop_quit
mainloop_run
mainloop_subscribe_signal
mainloop_unsubscribe_signal
model_signal_invoke
ns_done
ns_identifier
ns_init
session_add
session_add_jsid
session_bytes_for_connection
session_close_connection
session_connection_free
session_connection_new
session_free
session_func
session_get
session_get_callback
session_get_jsid
session_new
session_open_connection
session_register_data_callback
session_register_file_callback
session_register_js_callback
session_send
session_sendf
session_sendvf
session_try_close_connection
signal_done
signal_free
signal_init
signal_invoke
signal_invoke_marshal
signal_new
signal_subscribe
signal_subscribe_last
signal_unsubscribe
string_remove
string_replace
string_rtrim
underpants_css
*/
