/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef rangemodel_h
#define rangemodel_h

#include "signals.h"
#include "uref.h"

typedef struct{
    URef ref;
    int min;
    int max;
    int value;
    Signal signal_changed;
    Signal signal_limits;
}RangeModel;

RangeModel* range_model_new(int min,int max,int value);
#define range_model_ref(a) u_ref_ref((URef*)a)
#define range_model_unref(a) u_ref_unref((URef*)a)

void range_model_set(RangeModel*,int);
void range_model_limits(RangeModel,int min,int max);
#define range_model_subscribe_changed(a,b,c) signal_subscribe(&(a)->signal_changed,(SignalHandler)b,c)
#define range_model_unsubscribe_changed(a,b) signal_unsubscribe(&(a)->signal_changed,b)
#define range_model_subscribe_limits(a,b,c) signal_subscribe(&(a)->signal_limits,(SignalHandler)b,c)
#define range_model_unsubscribe_limits(a,b) signal_unsubscribe(&(a)->signal_limits,b)

#endif /* rangemodel_h */
