/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef strutil_h
#define strutil_h

#include <stdarg.h>

#include "memutil.h"

#ifdef USE_GLIB
# include <glib.h>
# define u_strdupf g_strdup_printf
# define u_strdupvf g_strdup_vprintf
# define u_strnatcoll g_utf8_collate_for_filename
#else
char* u_strdupf(const char* format,...) __attribute__((format(printf,1,2)));
char* u_strdupvf(const char* format,va_list);
#endif
char* u_strset_steal(char** dst,char* src);
#define u_strset(a,b) u_strset_steal(a,(b)?u_strdup((b)?(b):(void*)-1):NULL)
#define u_strsetn(a,b,c) u_strset_steal(a,(b)?u_strndup((b)?(b):(void*)-1,c):NULL)

char* string_remove(char* string,char* characters);
const char* string_replace(char* string,char* oldtok,char* newtok);
char* string_rtrim(char* s);

int u_strnatcmp(const char*,const char*);

#endif /* strutil_h */
