/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#include "priv.h"

#include "debug.h"
#include "memutil.h"
#include "listmodel.h"
#include "strutil.h"
#include "up.h"


static ListModel* model;

static int on_add(void* userdata,UpSession* c){
    static int num;
    char* label = u_strdupf("Item %d",++num);
    DEBUG_p("Click!");
    list_model_store_append(model,label);
    u_free(label);
    return 1;
}


static int on_del(void* userdata,UpSession* c){
    DEBUG_p("Click!");
    return 1;
}


static int on_init(void* userdata,UpWidget* root){
    UpWidget* vbox = up_vbox_new(0,0);
    UpWidget* hbox = up_button_box_new(0,0);
    up_box_add(vbox,up_image_new("kirby.gif"));
    model = list_model_store_new(NULL);
    up_container_add(root,vbox);
    up_box_pack_start(vbox,up_list_view_new(model),1,1,0);
    up_box_add(vbox,hbox);
    up_box_add(hbox,up_button_new_x("Add item",(SignalHandler)on_add));
    up_box_add(hbox,up_button_new_x("Remove item",(SignalHandler)on_del));
    return 1;
}


int main(int argc,char** argv){
    up_init(8080,on_init);

    up_main();

    up_done();
    return 0;
}
