/*
 * Copyright (C) 2015 Magnus Bergman
 *
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#ifndef USE_GLIB

#include <pthread.h>

#include "memutil.h"
#include "thread.h"

typedef void*(*ThreadFunc)(void*);

Thread* thread_dispatch(DispatchFunc func,void* data){
    Thread* thread = u_new(Thread,1);
    if(pthread_create(&thread->thread,NULL,(ThreadFunc)func,data)){
        u_free(thread);
        return NULL;
    }
    return thread;
}


void thread_join(Thread* thread){
    pthread_join(thread->thread,NULL);
    u_free(thread);
}

#endif /* ! USE_GLIB */
