/*
 * Copyright (C) 2016 Magnus Bergman
 *
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include "priv.h"

#include "debug.h"
#include "fileinfo.h"
#include "upstock.h"
#include "strutil.h"

#define PREFIX "/usr"
#define THEME1 "Tango"
#define THEME2 "gnome"

char* up_stock_get_filename(const char* id,int size){
    char* filename;
    filename = u_strdupf(PREFIX "/share/icons/" THEME1 "/%dx%d/%s.png",size,size,id);
    DEBUG_p("filename: %s",filename);
    if(file_exists(filename))
        return filename;
    u_free(filename);
    filename = u_strdupf(PREFIX "/share/icons/" THEME2 "/%dx%d/%s.png",size,size,id);
    DEBUG_p("filename: %s",filename);
    if(file_exists(filename))
        return filename;
    u_free(filename);
    return u_strdupf(PREFIX "/share/icons/" THEME1 "/%dx%d/" UP_STOCK_MISSING_IMAGE ".png",size,size);
}
