/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef uref_h
#define uref_h

#ifdef DEBUG
void DEBUG_ref_init(void);
void DEBUG_ref_done(void);
void DEBUG_ref_reg_full(void* obj,int* refcount,char*);
#define DEBUG_ref_reg(a,b) DEBUG_ref_reg_full(a,&(a)->count,u_strdup(b));
#define DEBUG_ref_regf(a,b,...) DEBUG_ref_reg_full(a,&(a)->count,g_strdup_printf(b,##__VA_ARGS__));
void DEBUG_ref_unreg(void*);
#else
# define DEBUG_ref_init()
# define DEBUG_ref_done()
# define DEBUG_ref_reg_full(a,b)
# define DEBUG_ref_reg(a,b)
# define DEBUG_ref_regf(a,b,...)
# define DEBUG_ref_unreg(a)
#endif

typedef void(*URefDestroyFunc)(void*);

typedef struct{
    int count;
    URefDestroyFunc destroy;
}URef;

URef* u_ref_init(URef*);
URef* u_ref_ref(URef*);
int u_ref_unref(URef*);

#endif /* uref_h */
