/*
 * Copyright (C) 2016 Magnus Bergman
 *
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include "../genjs.h"
#include "../memutil.h"
#include "expander.h"

typedef UpWidget UpExpander;

/* --- genjs -------------------------------------------------------- */

void genjs_expander_create(UpWidget* w,const char* name){
    Session* sess = w->session;
    //out("%s=[" EXPAND_WIDTH ":%d," EXPAND_HEIGHT ":%d];",name,w->expand_x,w->expand_y);
    out("%s={mw:0,mh:0," EXPAND_WIDTH ":1," EXPAND_HEIGHT ":1};",name);
}

/* --- expander widget ---------------------------------------------- */

UpWidget* up_expander_new(int ew,int eh){
    static const UpWidgetInterface up_expander_vt = {
        .done = up_widget_done_func,
        .genjs = genjs_expander_create
    };
    UpWidget* w = up_widget_init((UpWidget*)u_new(UpExpander,1));
    DEBUG_ref_reg((URef*)w,"Expander");
    w->vt = &up_expander_vt;
    w->expand_width = ew;
    w->expand_height = eh;
    return w;
}
