/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef up_widget_h
#define up_widget_h

#include "../uref.h"

typedef struct _UpSession UpSession;
typedef struct _UpWidget UpWidget;
typedef void(*GenjsCreateWidgetFunc)(UpWidget*,const char* name);

typedef struct{
    void(*done)(UpWidget*);
    void(*genjs)(UpWidget*,const char* name);
    void(*link)(UpWidget*);
}UpWidgetInterface;

struct _UpWidget{
    URef ref;
    const UpWidgetInterface* vt;
    UpSession* session;
    UpWidget* parent;
#if 0
    int x;
    int y;
    int width;
    int height;
#endif
    int margin;
    unsigned int expand_width:1;
    unsigned int expand_height:1;
    unsigned int fill_width:1;
    unsigned int fill_height:1;
    /* only used with tables */
    int cell_x;
    int cell_y;
    int cell_width;                     /**< Width in number of cells. */
    int cell_height;                    /**< Height in number of cells. */
};

void genjs_create_element_request_geometry(UpSession*,const char*);
#define genjs_get_element_request_geometry() genjs_get_function(sess,genjs_create_element_request_geometry)
void genjs_create_element_set_geometry(UpSession*,const char*);
#define genjs_get_element_set_geometry() genjs_get_function(sess,genjs_create_element_set_geometry)
void genjs_create_element_init(UpSession*,const char*);
#define genjs_get_element_init() genjs_get_function(sess,genjs_create_element_init)

UpWidget* up_widget_init(UpWidget*);
#define up_widget_ref(a) (UpWidget*)u_ref_ref((URef*)a)
#define up_widget_unref(a) u_ref_unref((URef*)a)
void up_widget_done_func(UpWidget*);

#define up_widget_link(a) if((a)->vt->link)(a)->vt->link(a)

#define up_widget_show(a) /* nothing */

#endif /* up_widget_h */
